#!/usr/bin/perl

# static char sccsid[] = "@(#)85 1.13 src/ll/config_editor/cgi-bin/login.pl, ll.config, ll_rrnep2, rrnep21206a 2/26/11 11:37:54\n";

use strict;
use lib "/var/www/ll/cgi-bin";
use LLUtil;
use DBI;
use CGI;
use CGI::Session;
use HTML::Template;

my $query;
read(STDIN,$query,$ENV{'CONTENT_LENGTH'});
$query = unescape($query);

debug_log($query);

$_ = $query;
if(/db_user=(.+)&db_pass=(.+)/)
{
	my $db_conn = undef;
	my $db2inst = undef;
	my $db_host = undef;
	my $db_db = undef;

	# get any info from ll.conf file
	open(CONF,"/var/www/ll/conf/ll.conf");
	while(<CONF>)
	{
		if(/hostname=(.+)/)
		{
			$db_host = $1;
		}
		elsif(/dbname=(.+)/)
		{
			$db_db = $1;
		}
	}
	close(CONF);

	# Try to get connection string from lsxcatd command
	my $cmd_name = undef;
	my $cmd_name = "/opt/xcat/bin/lsxcatd";
	my $cmd_run = "/opt/xcat/bin/lsxcatd -d";
	$db_conn = `$cmd_run`;
	if($? != 0)
	{
		debug_log("lsxcatd -d returned ".$?);

		if (-e $cmd_name)
		{ # lsxcatd exists but returns bad rc
			debug_log("lsxcatd -d bad return, exiting ");
			use constant TMPL_FILE => LLUtil::TMPL_DIR."/llconfig_login.tmpl";
			my $tmpl = new HTML::Template(filename => TMPL_FILE);
			$tmpl->param("msg" => "Error: No connection string was obtained from xcat (lsxcatd).");
			print "Content-type: text/html\n\n";
			print $tmpl->output;
			exit 1;
		}
		else
		{ # No lsxcatd command. Assume original MySQL prior to lsxcatd command
			$db_conn = "mysql:database=".$db_db.";host=".$db_host;
		}
	}
	else 
	{ # Process the connection string from lsxcatd
		# Just look at the first line
		my @tmp2 = split("\n", $db_conn);
		# Take part after the =  
		## DB2: cfgloc=DB2:xcatdb|xcatdb
		## MySQL: cfgloc=mysql:dbname=xcatdb;host=192.168.5.3|xcatadmin
		my @tmp = split("cfgloc=",@tmp2[0]);
		debug_log("tmp[1]=".@tmp[1]);
		# Take part before the |
		@tmp2 = split('\|',@tmp[1]);
		debug_log("tmp2[0]=".@tmp2[0]);
		debug_log("tmp2[1]=".@tmp2[1]);
		$db_conn = @tmp2[0];
	}
	debug_log("connection string=".$db_conn);

	my $db_user = $1;
	my $db_pass = $2;

	if ($db_conn =~ /^DB2/)
	{
		my $db_hold = undef;
		($db_hold, $db2inst) = split('\:', $db_conn);
		if ($db2inst ne $db_user)
		{
			debug_log("Instance ID (".$db2inst.") does not match login ID (".$db_user.")");
			use constant TMPL_FILE => LLUtil::TMPL_DIR."/llconfig_login.tmpl";
			my $tmpl = new HTML::Template(filename => TMPL_FILE);
			$tmpl->param("msg" => "Login using the DB2 Instance ID.");
			print "Content-type: text/html\n\n";
			print $tmpl->output;
			exit 1;
		}
		$ENV{'DB2INSTANCE'} = $db_user;
	}

	my $dbh = DBI->connect("DBI:".$db_conn,$db_user,$db_pass);
	debug_log("DBI:".$db_conn.",".$db_user.",".$db_pass);
	if(defined($dbh))
	{
		$dbh->disconnect();
		
		my $cgi = CGI->new;
		my $session = new CGI::Session(undef, $cgi, {Directory=>'/tmp'});
		my $sid = $session->id();
		my $cookie = $cgi->cookie(CGISESSID => $sid);
		$session->param("db_user", rsa_encrypt($db_user));
		$session->param("db_pass", rsa_encrypt($db_pass));
		$session->param("db_host", rsa_encrypt($db_host));
		$session->param("db_db", rsa_encrypt($db_db));
		$session->param("db_conn", rsa_encrypt($db_conn));
		$session->param("db2inst", rsa_encrypt($db2inst));

		debug_log("write into:".$session->param("db_user")."-".$session->param("db_pass")."-".$session->param("db_host")."-".$session->param("db_db"));
                my $rc = 0xffff & system "find /tmp/cgisess_* -mtime +7 | xargs rm -rf";
                if($rc != 0)
                {
                        debug_log("Error when trying to remove the old session files. rc=".$rc);
                }

		print $cgi->redirect(-uri => "/ll/llconfig_editor.pl", -cookie => $cookie);
	}
	else
	{
		use constant TMPL_FILE => LLUtil::TMPL_DIR."/llconfig_login.tmpl";
		my $tmpl = new HTML::Template(filename => TMPL_FILE);
		$tmpl->param("msg" => "Error: the name or password entered for host ".$db_host." and db ".$db_db." is not valid.");
		print "Content-type: text/html\n\n";
		print $tmpl->output;
	}

}
else
{
	$query = $ENV{QUERY_STRING};
	$query = unescape($query);
	my $cgi = CGI->new;
	if($query =~ /operation=logout/)
	{
		my $sid = $cgi->cookie("CGISESSID") || undef;
		if(defined($sid))
		{
			my $session = new CGI::Session(undef, $sid, {Directory=>'/tmp'});
			$session->clear();
			debug_log("logout!!");
		}
	}
	print $cgi->redirect("/ll/llconfig_editor.pl");
}


