#!/usr/bin/perl

# static char sccsid[] = "@(#)30 1.12 src/ll/config_editor/cgi-bin/pull_down_tab_panel_scheduler_features.pl, ll.config, ll_rrnep2, rrnep21206a 1/12/10 03:38:23\n";

use strict;
use lib "/var/www/ll/cgi-bin";
use LLUtil;
use DBI;

my @normal_tables_by_nodeID = ();
my @normal_tables_by_clusterID = ();
my @editable_tables_by_clusterID = ();

my $query = $ENV{QUERY_STRING};
$query = unescape($query);

$_ = $query;
if(/subpanel=(.+)&id=(\d+)&name=(.*)/)
{
	my $subpanel = $1;
	my $nodeID = $2;
	my $clusterID = $2;
	my $clusterName = $3;
	my $nodeName = $3;

	if($subpanel eq "tab_panel_scheduler")
	{
		@normal_tables_by_clusterID = @{LLUtil::ALL_TABLES->{"tab_panel_scheduler"}->[0]};
		@editable_tables_by_clusterID = @{LLUtil::ALL_TABLES->{"tab_panel_scheduler"}->[1]};
	}
	elsif($subpanel eq "tab_panel_preempt")
	{
		@normal_tables_by_nodeID = @{LLUtil::ALL_TABLES->{"tab_panel_preempt"}->[0]};
	}
	elsif($subpanel eq "tab_panel_class_rules")
	{
		#	preempt and start class
	}
	elsif($subpanel eq "tab_panel_reservation")
	{
		@normal_tables_by_clusterID = @{LLUtil::ALL_TABLES->{"tab_panel_reservation"}->[0]};
	}
	elsif($subpanel eq "tab_panel_bg")
	{
		@normal_tables_by_clusterID = @{LLUtil::ALL_TABLES->{"tab_panel_bg"}->[0]};
	}
	elsif($subpanel eq "tab_panel_fairshare")
	{
		@normal_tables_by_clusterID = @{LLUtil::ALL_TABLES->{"tab_panel_fairshare"}->[0]};
	}
	elsif($subpanel eq "tab_panel_dstg")
	{
		@normal_tables_by_clusterID = @{LLUtil::ALL_TABLES->{"tab_panel_dstg"}->[0]};
	}
	else
	{
		print LLUtil::OUTPUT_HEADER."Error: Unknown sub panel name.";
		exit 1;
	}
	
	# create the db connection
	my $dbh = get_dbh(0);
	if(!defined($dbh))
	{
		error_and_exit(DBI->errstr);
	}	
	
	my $json_str = LLUtil::OUTPUT_HEADER."[";

	# get string of default values
	if($subpanel eq "tab_panel_preempt")
	{
		my $default_node_id = undef;
		$default_node_id = get_default_id_by_primary_key($dbh,"nodeID","clusterID","TLL_Nodelist","hostname",$nodeID);
		# Get default values
		if(defined($default_node_id))
		{
			my $is_default = 0;
			if($default_node_id == $nodeID) { $is_default = 1; }
			$json_str .= get_default_json_str($dbh,"tab_panel_preempt","nodeID",$default_node_id,$is_default);
		}
	}
	else
	{
		# Get default cluster id
		my $default_cluster_id = undef;
		$default_cluster_id = get_default_cluster_id($dbh,"clusterID","TLL_Cluster","name");
		
		# Get default values
		if(defined($default_cluster_id))
		{
			my $is_default = 0;
			if($default_cluster_id == $clusterID) { $is_default = 1; }
			if($subpanel eq "tab_panel_class_rules")
			{
				# Get default string of preempt class and start class
				$json_str .= get_default_json_str_of_preempt($dbh,$default_cluster_id,$is_default);
			}
			else
			{
				$json_str .= get_default_json_str($dbh,$subpanel,"clusterID",$default_cluster_id,$is_default);
			}
		}	
	}

	my $sql_str = "";
	my $sth = undef;
	
	foreach my $table (@normal_tables_by_nodeID)
	{
		$sql_str="select * from ".$table." where nodeID=".$nodeID;
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			error_and_exit($dbh->errstr);
		}
		my $ary_ref = $sth->fetchrow_arrayref;
		my $i = 0;
		$json_str .= "{type:'normal',id:'".$table."-id"."',value:'".$nodeID."'},";
		if(exists $ary_ref->[$i])
		{
		    for($i=1;$i<$sth->{NUM_OF_FIELDS};$i++)
		    {
				$json_str .= "{type:'normal',id:'".$table."-".$sth->{NAME}->[$i]."',value:'".$ary_ref->[$i]."'},";
		    }
		}
	}

	foreach my $table (@normal_tables_by_clusterID)
	{
		$sql_str="select * from ".$table." where clusterID=".$clusterID;
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			error_and_exit($dbh->errstr);
		}
		my $ary_ref = $sth->fetchrow_arrayref;
		my $i = 0;
		$json_str .= "{type:'normal',id:'".$table."-id"."',value:'".$clusterID."'},	";
		if(exists $ary_ref->[$i])
		{
		    for($i=1;$i<$sth->{NUM_OF_FIELDS};$i++)
		    {
				$json_str .= "{type:'normal',id:'".$table."-".$sth->{NAME}->[$i]."',value:'".$ary_ref->[$i]."'},";
		    }
		}
	}

	foreach my $table (@editable_tables_by_clusterID)
	{
		$sql_str="select * from ".$table." where clusterID=".$clusterID;
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			error_and_exit($dbh->errstr);
		}
		$json_str .= "{type:'editable',table_name:'".$table."',key_id:'".$clusterID."',rows:[";
		while(my $ary_ref = $sth->fetchrow_arrayref)
		{
			$json_str .= "{columns:[";
			my $i;
			for($i=1;$i<$sth->{NUM_OF_FIELDS};$i++)
			{
				$json_str .= "{col_name:\'".$sth->{NAME}->[$i]."\',col_value:'".$ary_ref->[$i]."',col_title:'".$sth->{NAME}->[$i]."'},";
			}
			$json_str =~ s/,$//g;
			$json_str .= "]},";
		}
		$json_str =~ s/,$//g;
		$json_str .= "]},";
	}	

	# TLLS_CFGPreemptClass, TLLS_CFGPreemptClassOutgoing
	if($subpanel eq "tab_panel_class_rules")
	{
		my $table = "TLLS_CFGPreemptClass";
		my $table2 = "TLLS_CFGPreemptClassOutgoing";
		$sql_str="select * from ".$table." where clusterID=".$clusterID;
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			error_and_exit($dbh->errstr);
		}
		my @tmp = ();
		my $idx = 0;
		while(my $ary_ref = $sth->fetchrow_arrayref)
		{
			#preemptID
			$tmp[$idx * 4 + 0] = $ary_ref->[0];
			#incoming_class
			$tmp[$idx * 4 + 1] = $ary_ref->[2];
			#all_or_enough
			$tmp[$idx * 4 + 2] = $ary_ref->[3];
			#method
			$tmp[$idx * 4 + 3] = $ary_ref->[4];
			$idx++;
		}
		$json_str .= "{type:'preemptclass',table_name:'".$table."',key_id:'".$clusterID."',rows:[";
		for(my $i=0;$i<$idx;$i++)
		{
			$json_str .= "{preempt_id:'".$tmp[$i * 4 + 0]."',";
			$json_str .= "incoming_class:'".$tmp[$i * 4 + 1]."',";
			$json_str .= "all_or_enough:'".$tmp[$i * 4 + 2]."',";
			$json_str .= "method:'".$tmp[$i * 4 + 3]."',";
			
			$json_str .= "outgoing_class:[";
			$sql_str="select * from ".$table2." where preemptID=".$tmp[$i * 4 + 0];
			$sth=$dbh->prepare($sql_str);
			if(!defined($sth->execute()))
			{
				error_and_exit($dbh->errstr);
			}
			while(my $ary_ref = $sth->fetchrow_arrayref)
			{
				$json_str .= "{oc:'".$ary_ref->[1]."'},";
			}
			$json_str =~ s/,$//g;
			$json_str .= "]},";
		}
		$json_str =~ s/,$//g;
		$json_str .= "]},";
	}

	# TLLS_CFGPreemptStartClass, TLLS_CFGPreemptStartClassRunningTasks
	if($subpanel eq "tab_panel_class_rules")
	{
		my $table = "TLLS_CFGPreemptStartClass";
		my $table2 = "TLLS_CFGPreemptStartClassRunningTasks";
		$sql_str="select TLLS_CFGPreemptStartClass.startID,TLLS_CFGPreemptStartClass.incoming_class,".
				"TLLS_CFGPreemptStartClassRunningTasks.running_class,TLLS_CFGPreemptStartClassRunningTasks.number_of_tasks".
				" from TLLS_CFGPreemptStartClass inner join TLLS_CFGPreemptStartClassRunningTasks ".
				"on TLLS_CFGPreemptStartClass.startID=TLLS_CFGPreemptStartClassRunningTasks.startID ".
				"and TLLS_CFGPreemptStartClass.clusterID=".$clusterID;
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			error_and_exit($dbh->errstr);
		}
		$json_str .= "{type:'startclass',table_name:'".$table."',key_id:'".$clusterID."',rows:[";
		while(my $ary_ref = $sth->fetchrow_arrayref)
		{
			$json_str .= "{startID:'".$ary_ref->[0]."',";
			$json_str .= "incoming_class:'".$ary_ref->[1]."',";
			$json_str .= "running_class:'".$ary_ref->[2]."',";
			$json_str .= "number_of_tasks:'".$ary_ref->[3]."'},";
		}
		$json_str =~ s/,$//g;
		$json_str .= "]},";
	}

	$json_str =~ s/,$//g;
	$json_str .= "]";
	print $json_str;
	if(defined($sth)) {$sth->finish();}
	$dbh->disconnect();

}
