#!/usr/bin/perl -wT

# static char sccsid[] = "@(#)42 1.15 src/ll/config_editor/cgi-bin/show_tab_panel_scheduler_features.pl, ll.config, ll_rrnep2, rrnep21206a 9/26/10 16:37:42\n";

use strict;
use lib "/var/www/ll/cgi-bin";
use LLUtil;
use HTML::Template;
use DBI;

#  "TLLS_CFGPreemptClass","TLLS_CFGPreemptClassOutgoing","TLLS_CFGPreemptStartClass","TLLS_CFGPreemptStartClassRunningTasks",
my @normal_tables_by_nodeID = ();	
my @normal_tables_by_clusterID = ();
my @editable_tables_by_clusterID = ();

# Create a HTML::Template
use constant TMPL_FILE => LLUtil::TMPL_DIR."/show_tab_panel_scheduler_features.tmpl";
my $tmpl = new HTML::Template(filename => TMPL_FILE);

my $query = $ENV{QUERY_STRING};
$query = unescape($query);

## The first pair of params tells which sub panel it is; pass it to template for TMPL_IF
my @pairs = split('&',$query);
my @tmp = split('=',$pairs[0]);
my $subpanel = $tmp[0];
$tmpl->param($subpanel => 1);
if($subpanel eq "tab_panel_scheduler")
{
	@normal_tables_by_clusterID = @{LLUtil::ALL_TABLES->{"tab_panel_scheduler"}->[0]};
	@editable_tables_by_clusterID = @{LLUtil::ALL_TABLES->{"tab_panel_scheduler"}->[1]};
}
elsif($subpanel eq "tab_panel_preempt")
{
	@normal_tables_by_nodeID = @{LLUtil::ALL_TABLES->{"tab_panel_preempt"}->[0]};
}
elsif($subpanel eq "tab_panel_class_rules")
{
#	preempt and start class
}
elsif($subpanel eq "tab_panel_reservation")
{
	@normal_tables_by_clusterID = @{LLUtil::ALL_TABLES->{"tab_panel_reservation"}->[0]};
}
elsif($subpanel eq "tab_panel_bg")
{
	@normal_tables_by_clusterID = @{LLUtil::ALL_TABLES->{"tab_panel_bg"}->[0]};
}
elsif($subpanel eq "tab_panel_fairshare")
{
	@normal_tables_by_clusterID = @{LLUtil::ALL_TABLES->{"tab_panel_fairshare"}->[0]};
}
elsif($subpanel eq "tab_panel_dstg")
{
	@normal_tables_by_clusterID = @{LLUtil::ALL_TABLES->{"tab_panel_dstg"}->[0]};
}
else
{
	print "Content-type: text/html\n\n";
	$tmpl->param(error_string => "Unknown sub panel name.");
	print $tmpl->output;
	exit 1;
}
# get db info for $db_conn
my ($db_host, $db_user, $db_pass, $db_db, $db_conn, $db2inst) = get_db_info(1);

# create the db connection
my $dbh = get_dbh(1);
if(!defined($dbh))
{
	error_and_exit(DBI->errstr);
}

# Get default id and name
my $default_id = undef;
my $default_name = undef;

# Get id and name
my $sql_str;
if($subpanel eq "tab_panel_preempt")
{
	$sql_str="select nodeID,hostname from TLL_Nodelist";
}
else
{
	$sql_str="select clusterID,name from TLL_Cluster";
}
my $sth=$dbh->prepare($sql_str);
if(!defined($sth->execute()))
{
	print "Content-type: text/html\n\n";
	$tmpl->param(error_string => $dbh->errstr);
	print $tmpl->output;
	exit 1;
}
my($id,$name);
$sth->bind_columns(undef,\$id,\$name);
my @pull_down=();
while($sth->fetch())
{
	if($name eq "default" || $name eq "Default")
	{
		$default_id = $id;
		$default_name = $name;
	}
	else
	{
		my %pair = (id => $id, name => $name);
		push @pull_down, \%pair;
	}
}

if(defined($default_id))
{
	my %pair = (id => $default_id, name => $default_name);
	@pull_down = (\%pair, @pull_down);
}
elsif(scalar(@pull_down) > 0)
{
	my %pair = %{$pull_down[0]};
	$default_id = $pair{"id"};
	$default_name = $pair{"name"};
}
$tmpl->param(pull_down => \@pull_down);

# Get default cluster id/name or default node id/name
my $default_cluster_id = undef;
my $default_cluster_name = undef;
my $default_node_id = undef;
my $default_node_name = undef;
if($subpanel eq "tab_panel_preempt")
{
	$default_node_id = $default_id;
	$default_node_name = $default_name;
}
else
{
	$default_cluster_id = $default_id;
	$default_cluster_name = $default_name;
}

foreach my $table (@normal_tables_by_nodeID)
{
	my @table_items = ();
	my $ary_ref = undef;
	if(defined($default_node_id))
	{
		$sql_str="select * from ".$table." where nodeID=".$default_node_id;
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			print "Content-type: text/html\n\n";
			$tmpl->param(error_string => $dbh->errstr);
			print $tmpl->output;
			exit 1;
		}
		$ary_ref = $sth->fetchrow_arrayref;
	}

	if(!defined($ary_ref))
	{
		$sql_str="select * from ".$table.get_only_one($db_conn);
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			print "Content-type: text/html\n\n";
			$tmpl->param(error_string => $dbh->errstr);
			print $tmpl->output;
			exit 1;
		}
	}

	$tmpl->param($table."-id" => $default_node_id);
	
	for(my $i=1;$i<$sth->{NUM_OF_FIELDS};$i++)
	{
		my $default = "";
		my $value = "";
		if(defined($ary_ref))
		{
			$value = $ary_ref->[$i];
		}

		my %item = (id => $table."-".$sth->{NAME}->[$i], 
			    name => $table."-".$sth->{NAME}->[$i],
			    title => $table."-".$sth->{NAME}->[$i],
			    display_name => $sth->{NAME}->[$i],
			    value => $value,
			    orig_id => "orig-".$table."-".$sth->{NAME}->[$i], 
			    orig_name => "orig-".$table."-".$sth->{NAME}->[$i], 
			    orig_value => $value,
			    default => $default
			   );
		push @table_items, \%item;
	}

	$tmpl->param($table."_items" => \@table_items);
	$tmpl->param($table."-primary_key" => $sth->{NAME}->[0]);				
}

foreach my $table (@normal_tables_by_clusterID)
{
	my @table_items = ();
	my $ary_ref = undef;
	if(defined($default_cluster_id))
	{
		$sql_str="select * from ".$table." where clusterID=".$default_cluster_id;
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			print "Content-type: text/html\n\n";
			$tmpl->param(error_string => $dbh->errstr);
			print $tmpl->output;
			exit 1;
		}
		$ary_ref = $sth->fetchrow_arrayref;
	}
	
	if(!defined($ary_ref))
	{
		$sql_str="select * from ".$table.get_only_one($db_conn);
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			print "Content-type: text/html\n\n";
			$tmpl->param(error_string => $dbh->errstr);
			print $tmpl->output;
			exit 1;
		}
	}
	$tmpl->param($table."-id" => $default_cluster_id);
	
	for(my $i=1;$i<$sth->{NUM_OF_FIELDS};$i++)
	{
		my $default = "";
		my $value = "";
		if(defined($ary_ref))
		{
			$value = $ary_ref->[$i];
		}
		
		my %item = (id => $table."-".$sth->{NAME}->[$i], 
			    name => $table."-".$sth->{NAME}->[$i],
			    title => $table."-".$sth->{NAME}->[$i],
			    display_name => $sth->{NAME}->[$i],
			    value => $value,
			    orig_id => "orig-".$table."-".$sth->{NAME}->[$i], 
			    orig_name => "orig-".$table."-".$sth->{NAME}->[$i], 
			    orig_value => $value,
			    default => $default
			   );
		push @table_items, \%item;
	}

	$tmpl->param($table."_items" => \@table_items);
	$tmpl->param($table."-primary_key" => $sth->{NAME}->[0]);
		
}

foreach my $table (@editable_tables_by_clusterID)
{
	my @table_display_items = ();
	my @table_input_items = ();
	$sql_str="select * from ".$table.get_only_one($db_conn);
	$sth=$dbh->prepare($sql_str);
	if(!defined($sth->execute()))
	{
		print "Content-type: text/html\n\n";
		$tmpl->param(error_string => $dbh->errstr);
		print $tmpl->output;
		exit 1;
	}
	my $m;
	for($m=1;$m<$sth->{NUM_OF_FIELDS};$m++)
	{
		#$sth->{TYPE}->[$m]
		my %item1 = (display_name => $sth->{NAME}->[$m]);
		push @table_display_items, \%item1;
		my %item2 = (name => $sth->{NAME}->[$m],
			     title => $sth->{NAME}->[$m]);
		push @table_input_items, \%item2;
	}
	$tmpl->param($table."_display_items" => \@table_display_items);
	$tmpl->param($table."_input_items" => \@table_input_items);
	$tmpl->param($table."-primary_key" => $sth->{NAME}->[0]."-".$sth->{NAME}->[1]);

	if(defined($default_cluster_id))
	{
		$sql_str="select * from ".$table." where clusterID=".$default_cluster_id;
		
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			print "Content-type: text/html\n\n";
			$tmpl->param(error_string => $dbh->errstr);
			print $tmpl->output;
			exit 1;
		}
		my $idx = 0;
		my @rows = ();
		while(my $ary_ref = $sth->fetchrow_arrayref)
		{
			# for table TLLR_CFGVars
			my @columns = ();
			my $i;
			for($i=1;$i<$sth->{NUM_OF_FIELDS};$i++)
			{
				my %col_item = (name => $sth->{NAME}->[$i],
						title => $sth->{NAME}->[$i],
						value => $ary_ref->[$i],
						orig_name => "orig-".$sth->{NAME}->[$i],
						orig_value => $ary_ref->[$i]);
				push @columns, \%col_item;
			}
			
			my %row_item = (columns => \@columns);
			push @rows, \%row_item;
			$idx++;
		}
		$tmpl->param($table."_rows" => \@rows);
		$tmpl->param($table."-id" => $default_cluster_id);
	}
}

if($subpanel eq "tab_panel_class_rules" && defined($default_cluster_id))
{
	{
		my $table = "TLLS_CFGPreemptClass";
		my $table2 = "TLLS_CFGPreemptClassOutgoing";
		$sql_str="select * from ".$table." where clusterID=".$default_cluster_id;
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			print "Content-type: text/html\n\n";
			$tmpl->param(error_string => $dbh->errstr);
			print $tmpl->output;
			exit 1;
		}
		my @tmp = ();
		my $idx = 0;
		while(my $ary_ref = $sth->fetchrow_arrayref)
		{
			#preemptID
			$tmp[$idx * 5 + 0] = $ary_ref->[0];
			#incoming_class
			$tmp[$idx * 5 + 2] = $ary_ref->[2];
			#all_or_enough
			$tmp[$idx * 5 + 3] = $ary_ref->[3];
			#method
			$tmp[$idx * 5 + 4] = $ary_ref->[4];
			$idx++;
		}
		my @table_items = ();
		for(my $i=0;$i<$idx;$i++)
		{
			$sql_str="select * from ".$table2." where preemptID=".$tmp[$i * 5 + 0];
			$sth=$dbh->prepare($sql_str);
			if(!defined($sth->execute()))
			{
				print "Content-type: text/html\n\n";
				$tmpl->param(error_string => $dbh->errstr);
				print $tmpl->output;
				exit 1;
			}
			my @outgoing = ();
			while(my $ary_ref = $sth->fetchrow_arrayref)
			{
				my %out_item = (outgoing_class => $ary_ref->[1]);
				push @outgoing, \%out_item;
			}
			my %item = ("TLLS_CFGPreemptClass-id" => "TLLS_CFGPreemptClass-id-".$tmp[$i * 5 + 0],
						"TLLS_CFGPreemptClass-name" => "TLLS_CFGPreemptClass-name-".$tmp[$i * 5 + 0],
						"incoming_class-id" => $table."-incoming_class-".$tmp[$i * 5 + 0],
						"incoming_class-name" => $table."-incoming_class-".$tmp[$i * 5 + 0],
						"incoming_class-value" => $tmp[$i * 5 + 2],
						"orig_incoming_class-id" => "orig-".$table."-incoming_class-".$tmp[$i * 5 + 0],
						"orig_incoming_class-name" => "orig-".$table."-incoming_class-".$tmp[$i * 5 + 0],
						"orig_incoming_class-value" => $tmp[$i * 5 + 2],
						"outgoing_table_name" => "TLLS_CFGPreemptClassOutgoing-".$tmp[$i * 5 + 0],
						"preempt_id" => $tmp[$i * 5 + 0],
						"all_or_enough-id" => $table."-all_or_enough-".$tmp[$i * 5 + 0],
						"all_or_enough-name" => $table."-all_or_enough-".$tmp[$i * 5 + 0],
						"orig_all_or_enough-id" => "orig-".$table."-all_or_enough-".$tmp[$i * 5 + 0],
						"orig_all_or_enough-name" => "orig-".$table."-all_or_enough-".$tmp[$i * 5 + 0],
						"orig_all_or_enough-value" => $tmp[$i * 5 + 3],
						"all_or_enough_".$tmp[$i * 5 + 3] => 1, 
						"method-id" => $table."-method-".$tmp[$i * 5 + 0],
						"method-name" => $table."-method-".$tmp[$i * 5 + 0],
						"orig_method-id" => "orig-".$table."-method-".$tmp[$i * 5 + 0],
						"orig_method-name" => "orig-".$table."-method-".$tmp[$i * 5 + 0],
						"orig_method-value" => $tmp[$i * 5 + 4],
						"method_".$tmp[$i * 5 + 4] => 1, outgoing_class_items => \@outgoing);
			push @table_items, \%item;
		}
		$tmpl->param(TLLS_CFGPreemptClass_items => \@table_items);
	}
	
	{
		my $table = "TLLS_CFGPreemptStartClass";
		my $table2 = "TLLS_CFGPreemptStartClassRunningTasks";
		$sql_str="select TLLS_CFGPreemptStartClass.startID,TLLS_CFGPreemptStartClass.incoming_class,".
				"TLLS_CFGPreemptStartClassRunningTasks.running_class,TLLS_CFGPreemptStartClassRunningTasks.number_of_tasks".
				" from TLLS_CFGPreemptStartClass inner join TLLS_CFGPreemptStartClassRunningTasks ".
				"on TLLS_CFGPreemptStartClass.startID=TLLS_CFGPreemptStartClassRunningTasks.startID ".
				"and TLLS_CFGPreemptStartClass.clusterID=".$default_cluster_id;
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			print "Content-type: text/html\n\n";
			$tmpl->param(error_string => $dbh->errstr);
			print $tmpl->output;
			exit 1;
		}
		my @table_items = ();
		while(my $ary_ref = $sth->fetchrow_arrayref)
		{
			my %item = ( #"start_id" => $ary_ref->[0],
						"TLLS_CFGPreemptStartClass-id" => "TLLS_CFGPreemptStartClass-id-".$ary_ref->[0]."-".$ary_ref->[2],
						"TLLS_CFGPreemptStartClass-name" => "TLLS_CFGPreemptStartClass-name-".$ary_ref->[0]."-".$ary_ref->[2],
						"start_running_id" => $ary_ref->[0]."-".$ary_ref->[2],
						"incoming_class-id" => $table."-incoming_class-".$ary_ref->[0]."-".$ary_ref->[2],
						"incoming_class-name" => $table."-incoming_class-".$ary_ref->[0]."-".$ary_ref->[2],
						"incoming_class-value" => $ary_ref->[1],
						"orig_incoming_class-id" => "orig-".$table."-incoming_class-".$ary_ref->[0]."-".$ary_ref->[2],
						"orig_incoming_class-name" => "orig-".$table."-incoming_class-".$ary_ref->[0]."-".$ary_ref->[2],
						"orig_incoming_class-value" => $ary_ref->[1],
						"running_class-id" => $table."-running_class-".$ary_ref->[0]."-".$ary_ref->[2],
						"running_class-name" => $table."-running_class-".$ary_ref->[0]."-".$ary_ref->[2],
						"running_class-value" => $ary_ref->[2],
						"orig_running_class-id" => "orig-".$table."-running_class-".$ary_ref->[0]."-".$ary_ref->[2],
						"orig_running_class-name" => "orig-".$table."-running_class-".$ary_ref->[0]."-".$ary_ref->[2],
						"orig_running_class-value" => $ary_ref->[2],
						"number_of_tasks-id" => $table."-number_of_tasks-".$ary_ref->[0]."-".$ary_ref->[2],
						"number_of_tasks-name" => $table."-number_of_tasks-".$ary_ref->[0]."-".$ary_ref->[2],
						"number_of_tasks-value" => $ary_ref->[3],
						"orig_number_of_tasks-id" => "orig-".$table."-number_of_tasks-".$ary_ref->[0]."-".$ary_ref->[2],
						"orig_number_of_tasks-name" => "orig-".$table."-number_of_tasks-".$ary_ref->[0]."-".$ary_ref->[2],
						"orig_number_of_tasks-value" => $ary_ref->[3]);
			push @table_items, \%item;
		}
		$tmpl->param(TLLS_CFGPreemptStartClass_items => \@table_items);
	}
	
}	
$sth->finish();
$dbh->disconnect();


print "Content-type: text/html\n\n";
print $tmpl->output;

